package Bastille::Shell;

use Bastille::IO;
@ENV="";
$ENV{PATH}="";
$ENV{CDPATH}=".";
$ENV{BASH_ENV}="";


&InstallScript;


sub InstallScript {

   print <<ENDIPCHAINSQUERY;

IPCHAINS:

ipchains allows you to do packet filtering/modification via the Linux kernel.
You can use this to block certain types of connections from/to your machine,
to turn your machine into a small firewall, and to do Network Address
Translation, or "IP masquerading", to let several machines share a single
IP address.

We have a particular script that will create firewalling instructions for you.
If we install the script, you will need to edit it for your particular site
and then individually activate it.

Would you like us to install the ipchains script?
ENDIPCHAINSQUERY

   if (&GetYN eq "Y") {

      &B_open(*ORIG_FIREWALL,"firewall_ipchains.txt");
      &B_open(*FIREWALL,">/etc/rc.d/init.d/bastille-firewall");

      while ($line=<ORIG_FIREWALL>) {
         print FIREWALL $line;
	 if ($line =~ /^#! \/bin\/sh/) {
	    print FIREWALL <<ENDCHKCFGADD;
#
# bastille-firewall      This shell script takes care of starting and stopping
#                        Bastille Linux's firewalling, via Peter W's script.
#
# chkconfig: 345 16 91
#
ENDCHKCFGADD
         }
      }

      &B_close(*FIREWALL);
      &B_close(*ORIG_FIREWALL);
      
      print <<ENDEXPLFW;
      
The firewalling script is called /etc/rc.d/init.d/bastille-firewall.  Please
edit it to configure it for your site.  You can then test it by using

     /etc/rc.d/init.d/bastille-firewall start
and
     /etc/rc.d/init.d/bastille-firewall stop
     
Once you have a configuration that will work on your system, you can make it
run at every normal boot-up by typing 

    /sbin/chkconfig bastille-firewall on
      
ENDEXPLFW
   }
}

1;

